#!/bin/bash
# Scritto e pubblicato il 5 agosto 2012 da Giovanni Ubaldi
# Istruzioni e download: http://www.ubaweb.it/miniguide/autoaggiorna_pagina.php
# Declino ogni responsabilità per problemi o danni di qualsiasia tipo,
# derivanti dall'utilizzo di questo script!

# configurazione: inserire il browser che si vuole utilizzare

reset

path_index="$HOME/.autoaggiorna_pagina/index.html" # path elenco pagine salvate
path_config="$HOME/.autoaggiorna_pagina/.autoaggiorna_pagina.conf" # path .conf
path_pagine="$HOME/.autoaggiorna_pagina/pagine_salvate" # path pagine salvate
pagina_tmp=$(tempfile) || exit							# path pagina temporanea
#pagina_tmp="$HOME/.autoaggiorna_pagina/temp.html"		# path pagina temporanea

# impostazioni predefinite
pagina_conf=$(cat <<TestoConfigurazione
browser='firefox'				# browser da utilizzare

memorandum='\tMemorandum (si può usare per il copia-incolla)

forum.ubuntu-it.org/viewforum.php?f=70	# progetti comunità Ubuntu
forum.ubuntu-it.org/viewtopic.php?f=70&t=562842	# discussione su questo script
http://forum.ubuntu-it.org/viewforum.php?f=33	# programmazione'

ognim=2				# intervallo di refresh
int_browser=3		# dopo quanti minuti si chiude la pagina
int_browser2=6		# dopo quanti minuti si riapre la pagina

TestoConfigurazione
)


#verfica connessione

if ! ping -c 1 www.google.com &>/dev/null
	then
		echo "Devi attivare la connessione per utilizzare questo script!"
		exit		
fi

# verifica esistenza o crea le directory di salvataggio
if [ ! -d "$path_pagine" ]; then
		mkdir -p "$path_pagine"
fi

# verifica esistenza o scrive il file di configurazione
if [ ! -w  "$path_config" ]
	then
		echo -e "$pagina_conf" > "$path_config"
fi
		
source "$path_config" # includo il file di configurazione

# acquisizione parametri passati da linea di comando
# 1° URL, 2°refresh, 3° int. chiusura, 4° int. riapertura, 5° browser
# i parametri devono essere inseriti nell'ordine indicato senza buchi a sinistra, 
# (altrimenti dovrei usare coppie incatenate! Futura vesione?)


if [ $# -ge 0 ];then

	if [ -n "$1" ]; then
		mod=0	# imposto esclusione della parte di modifica
		if [[ "$1" =~ ^http://.*$ ]]
			then
				url=$1
			else
				url="http://$1"
		fi
	fi
	
	if [ -n "$2" ]; then
		if [[ "$2" =~ ^[0-9]+$ ]]
			then
				ognim=$2
			else
				echo "Attenzione! Il parametro 2 deve essere un intero positivo"
				exit 1
		fi
	fi
	
	if [ -n "$3" ]; then
		if [[ "$3" =~ ^[0-9]+$ ]]
			then
				int_browser=$3
			else
				echo "Attenzione! Il parametro 3 deve essere un intero positivo"
				exit 1
		fi
	fi
	
	if [ -n "$4" ]; then
		if [[ "$4" =~ ^[0-9]+$ ]]
			then
				int_browser2=$4
			else
				echo "Attenzione! Il parametro 4 deve essere un intero positivo"
				exit 1
		fi
	fi
	
	if [ -n "$5" ]; then
		if [ $(which "$5") ]
			then
				browser=$5
			else
				echo "Attenzione! Browser indicato ($5) non trovato!"
				exit 1
		fi
	fi
	
fi

echo -e "Le impostazioni attuali sono:
url:$url
browser scelto: $browser
refresh pagina ogni: $ognim minuti
chiusura pagina ogni: $int_browser minuti
riapertura pagina ogni: $int_browser2 minuti\n"



if [[ $mod != 0 ]]
	then
		echo -e "Vanno bene?\ntasto 'Invio' o altro tasto per continure senza modifiche\n'M' per modificare le impostazioni temporaneamente o renderle predefinite"
		read -n1 scelta
		if [[ $scelta == "m" || $scelta == "M" ]]; then

			clear
	
			echo -e "\n\nl'intervallo di refresh è: $ognim  \n\nvuoi cambiarlo? 'S' si, 'Invio'(o altro) salta"
			read -n1 scelta
			if [[ $scelta == "s" || $scelta == "S" ]]; then
				ognim=''
				echo -e "\nOgni quanti minuti aggiornare la pagina?"
				while ! [[ "$ognim" =~ ^[0-9]+$ ]] 
					do
						echo "(inserire un intero positivo, poi Invio))"
						read ognim
				done
			fi
	
			clear

			echo -e "\nla pagina si chuide dopo: $int_browser minuti  \n\ncambiare? 'S' si, 'Invio'(o altro) salta"
			read -n1 scelta
			if [[ $scelta == "s" || $scelta == "S" ]]; then
				int_browser=''
				echo -e "\nQuanto tempo tenere aperta la pagina di $browser?\n\t'0' disattiva apertura e chiusura temporizzata della pagina web!\n\t(si apre $browser e termina lo script,\n\tla pagina aperta si aggiornerà automaticamente ogni $ognim)"
				while ! [[ "$int_browser" =~ ^[0-9]+$ ]] 
				do
					echo "(inserire un intero positivo, poi Invio))"
					read int_browser
				done 
			fi
	
			clear	
	
			if [ $int_browser -ne 0 ]
				then

					echo -e "\nla pagina si riapre dopo: $int_browser2 minuti\n\ncambiare? 'S' si, 'Invio'(o altro) salta"
					read -n1 scelta
					if [[ $scelta == "s" || $scelta == "S" ]]; then
							int_browser2=''
							echo -e "\nDopo quanto tempo riaprire la pagina?"
							  while ! [[ "$int_browser2" =~ ^[0-9]+$ ]] 
								do
								echo "(inserire un intero positivo, poi Invio))"
								read int_browser2
							  done
					fi
			fi
	
			clear
	
			echo -e "\nbrowser: $browser, vuoi cambiarlo? 'S' si, 'Invio'(o altro) salta"
			read -n1 scelta
			if [[ $scelta == "s" || $scelta == "S" ]]; then
				echo -e "\ninserisci il nome del browser che vuoi usare"
				read browser
			fi
	
			clear
	
			echo -e "\nmemorandum: $memorandum \n\nvuoi cambiarlo? 'S' si, 'Invio'(o altro) salta"
			read -n1 scelta
			if [[ $scelta == "s" || $scelta == "S" ]]; then
				echo -e "\ninserisci il tuo memorandum./nPuoi usare Invio per andare a capo, per finire digita '@'"
				read -d '@' memorandum
			fi
	
			clear
	
			echo -e "\n\nVuoi rendere predefinite queste scelte? 'S' si, 'Invio'(o altro) salta"
			read -n1 scelta
			if [[ $scelta == "s" || $scelta == "S" ]]; then
	
		nuova_conf=$(cat <<NuovaConfigurazione
		browser='$browser'				# browser da utilizzare

		memorandum='$memorandum'

		ognim=$ognim					# intervallo di refresh
		int_browser=$int_browser		# dopo quanti minuti si chiude la pagina
		int_browser2=$int_browser2		# dopo quanti minuti si riapre la pagina

NuovaConfigurazione
		)

			# scrittura nuova configurazione
			echo -e "$nuova_conf" > "$path_config"
			fi
	
		fi # fine modifiche

apri_pagina=$(which $browser)

		clear
			 if [ -z "$1" ]; then
			 
			 # se sono presenti file html nella dir di salvataggio creo index.html
if [[ $(ls "$path_pagine/"*.html 2>/dev/null) ]] 
	then 
		echo -e "Lista dei file salvati!\n 'V': vedi, 'S':svuota, 'E': elimina un file, altro: continua"
		read -n1 opz_lista

		# elimino il file lista e tutte le pagine salvate
		if [[ $opz_lista == "s" || $opz_lista == "S" ]]; then
			rm -f $path_index 2>/dev/null
			rm -f "$path_pagine/"*.html 2>/dev/null
			
		# scelta pagina salvata e sua eliminazione	
		elif [[ $opz_lista == "e" || $opz_lista == "E" ]]; then
			clear
			echo -e "le pagine salvate sono:\n"
			for f_salvato in "$path_pagine/"*.html
			do
				echo $(basename "$f_salvato")
			done
			echo -e "\nCopia/incolla o scrivi il nome del file da eliminare (Invio: continua)"
			read file_canc
			rm -f "$path_pagine/$file_canc" 2>/dev/null
			rigenera_lista=1
			
		# creazione e visualizzazione lista di links alle pagine salvate
		elif [[ $opz_lista == "v" || $opz_lista == "V" || $rigenera_lista -eq 1 ]]; then
			for f in "$path_pagine/"*.html
			do
				links+=$(echo "<a href=\"file://$f\" target=\"_blank\">"$(basename $f)"</a><br>\n")
			done
			
			pagina_elenco=$(cat <<paginaElenco
<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Elenco Pagine Autoaggiornanti Salvate</title>
</head>
<body>
<h2>Elenco Pagine Autoaggiornanti Salvate</h1>
<p>I links aprono le pagine in nuovi tab del browser.<br><br>
$links
</p>
</body>
</html>
paginaElenco
)
			echo -e "$pagina_elenco" > "$path_index"
			$apri_pagina "$path_index" &
			exit
			
		fi
	else 
		echo "Non sono presenti pagine salvate"; 
fi
			 
			 
			 
			 	echo -e "\n$memorandum\n"
				echo -e "inserire l'indirizzo della pagina da aggiornare automaticamente\n(con o senza http://) e premere Invio\n"
				read url
				if [[ ! "$url" =~ ^http://.*$ ]] 
					then
						url="http://$url"
				fi
				
			 fi
fi
# CORE ->

ogni=$((ognim*60))	# minuti->secondi tra un aggiornamento e l'altro

pagina=$(cat <<bloccoDiTestoInVariabile
<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta http-equiv="refresh" content="$ogni; URL=$pagina_tmp">
<title>Ricarica la pagina $pagina_tmp</title>
</head>

<frameset rows="0,*" frameborder="NO" border="0" framespacing="0">
	<frame name="top_f" scrolling="NO" noresize >
	<frame src="$url" name="pagina">
</frameset>
<noframes><body>
</body></noframes>
</html>
bloccoDiTestoInVariabile
)

echo "$pagina"  > $pagina_tmp

echo -e "\nSalvare la pagina per un utilizzo successivo? 'S': si, altro: continua!"
		read -n1 salva
		if [[ $salva == "s" || $salva == "S" ]]; 
			then
				echo -e "\ninserisci un nome rappresentativo e premi Invio"
				read nome_file
				nome_file=${nome_file// /_} # sostituisce gli spazi con underscore
				pagina_s=$(cat <<paginaDaSalvare
<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta http-equiv="refresh" content="$ogni; URL=file://$path_pagine/${nome_file}.html">
<title>Ricarica la pagina $nome_file</title>
</head>

<frameset rows="0,*" frameborder="NO" border="0" framespacing="0">
	<frame name="top_f" scrolling="NO" noresize >
	<frame src="$url" name="pagina">
</frameset>
<noframes><body>
</body></noframes>
</html>
paginaDaSalvare
)
				#cp $pagina_tmp "$path_pagine/${nome_file}.html"
				echo "$pagina_s" > "$path_pagine/${nome_file}.html"
		fi
		
if [ $int_browser -ne 0 ]
	then
		echo "Attendere, verrà aperta la pagina..."
		echo "chiusa dopo $int_browser minuti e riaperta dopo $int_browser2."
		echo "La pagina si aggiornerà ogni $ognim minuti"
		echo -e "\n\tCTRL+C per uscire"
		while :
			do
				$apri_pagina "$pagina_tmp" &
				sleep ${int_browser}m
				killall $browser
				sleep ${int_browser2}m
		done
	else
		echo "attendere verrà aperto $browser e terminato lo script"
		$apri_pagina "$pagina_tmp" &
		exit	
fi

exit
